/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.43 from the
 * contents of Bencode_XS.xs. Do not edit this file, edit Bencode_XS.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "Bencode_XS.xs"
#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

/* this is a trimmed down version of Perl_sv_cmp which doesn't consider
 * locale and UTF8: i hope this to be  more compliant with Bencode specs  */
static int _raw_cmp(const void *v1, const void *v2) {
    STRLEN cur1, cur2;
    char *pv1, *pv2;
    int cmp, retval;
        
    pv1 = SvPV(*(SV **)v1, cur1);
    pv2 = SvPV(*(SV **)v2, cur2); 
    
    retval = memcmp((void*)pv1, (void*)pv2, cur1 < cur2 ? cur1 : cur2);
    if (retval) {
        cmp = retval < 0 ? -1 : 1;
    } else if (cur1 == cur2) {
        cmp = 0;
    } else {
        cmp = cur1 < cur2 ? -1 : 1;
    }

    return cmp;
}


static bool _is_int(char *pv, STRLEN len, STRLEN *offset) {
    STRLEN i = 0;
    bool is_int = 0;
    bool first_zero = 0;
    bool plus = 0;
    bool minus = 0;
    if (pv[0] == '+') i = plus = 1;
    if (pv[0] == '-') i = minus = 1;
        
    for (;i < len;i++) {
        if (isDIGIT(pv[i])) {
            if (!is_int && pv[i] == '0') {
                if (first_zero) {
                    first_zero = 0;
                    break;
                } else {
                    first_zero = 1;
                    continue;
                }
            }
            is_int = 1;
        } else {
            return 0;
        }
    }
    if (is_int ^ first_zero) {
        *offset = (plus || (minus && first_zero)) ? 1 : 0;
        return 1;
    } else {
        return 0;
    }
}

static void _bencode(SV *line, SV *stuff, bool coerce, bool hkey) {
    char *pv;
    STRLEN len, offset;
    
    if (hkey) {
        pv = SvPV(stuff, len);
        sv_catpvf(line, "%d:", len);
        sv_catpvn(line, pv, len);
        return;
    }
    if (SvIOK(stuff) && !SvNOK(stuff) && !SvPOK(stuff)) {
        sv_catpvf(line, "i%de", SvIVX(stuff));
        return;
    }
    if (SvROK(stuff)) {
        switch (SvTYPE(SvRV(stuff))) {
            AV *av, *keys;
            HV *hv;
            SV *sv; 
            HE *entry; 
            I32 len, i;
            case SVt_PVAV:
                sv_catpv(line, "l");
                av = (AV*)SvRV(stuff);
                len = av_len(av) + 1;
                for (i = 0; i < len; i++) {
                    _bencode(line, *av_fetch(av, i, 0), coerce, 0);
                }
                sv_catpv(line, "e");
                break;
            case SVt_PVHV:
                sv_catpv(line, "d");
                hv = (HV*)SvRV(stuff);
                keys = (AV*)sv_2mortal((SV*)newAV());
                (void)hv_iterinit(hv);
                while ((entry = hv_iternext(hv))) {
                    sv = hv_iterkeysv(entry);
                    (void)SvREFCNT_inc(sv);
                    av_push(keys, sv);
                }
                qsort(AvARRAY(keys), av_len(keys) + 1, sizeof(SV*), _raw_cmp);
                len = av_len(keys) + 1;
                for (i = 0; i < len; i++) {
                    sv = *av_fetch(keys, i, 0);
                    _bencode(line, sv, coerce, 1);
                    _bencode(line, HeVAL(
                        hv_fetch_ent(hv, sv, FALSE, 0)
                     ), coerce, 0); 
                }
                sv_catpv(line, "e");
                break;
            default:
                croak("Cannot serialize this kind of reference: %_", stuff);
        }
        return;
    }
    pv = SvPV(stuff, len);
    if (coerce && _is_int(pv, len, &offset)) {
        sv_catpvf(line, "i%se", pv + offset);
    } else {
        sv_catpvf(line, "%d:", len);
        sv_catpvn(line, pv, len);
    }
}

/* Decode XS implementation by Andrew Danforth <adanforth@gmail.com>, 
 * based entirely upon the Perl implementation by Giulio Motta */

struct decode_stack_entry {
   SV *sv;
   SV *key;
};

struct decode {
   struct decode_stack_entry *stack_entries;
   int stack_size;
   int stack_next;

   char *start;
   char *end;
   STRLEN len;

   char *ptr;
};

static void decode_free(struct decode *decode) {
   for(; decode->stack_next; decode->stack_next--) {
      struct decode_stack_entry *e = &decode->stack_entries[decode->stack_next - 1];
      if (e->sv)  SvREFCNT_dec(e->sv);
      if (e->key) SvREFCNT_dec(e->key);
   }
   Safefree(decode->stack_entries);
}

#define decode_height(s) (s->stack_next)
#define decode_top(s) (&s->stack_entries[s->stack_next - 1])
#define decode_pop(s) (&s->stack_entries[--s->stack_next])

static void decode_push(struct decode *decode, SV *sv) {
   if (decode->stack_next == decode->stack_size) {
      decode->stack_size <<= 1;
      Renew(decode->stack_entries, decode->stack_size, struct decode_stack_entry);
   }

   decode->stack_entries[decode->stack_next].sv = sv;
   decode->stack_entries[decode->stack_next].key = NULL;
   decode->stack_next++;
}

#define DECODE_CROAK(msg) { \
      decode_free(decode); \
      croak("bdecode error: %s: pos %d, %s", msg, decode->ptr - decode->start, decode->start); \
   }
#define OVERFLOW_IF(exp) if (exp) DECODE_CROAK("overflow")

static STRLEN find_num(struct decode *decode, char endchr, int allow_sign) {
   char *s = decode->ptr;
   char sign = 0;

   if (s != decode->end && allow_sign && (*s == '+' || *s == '-'))
      sign = *s++;

   for(; s < decode->end; s++) {
      if (*s == endchr) {
         STRLEN len = s - decode->ptr;
         if (sign && len == 1) 
            DECODE_CROAK("invalid number");
         return(len);
      } else if (!isDIGIT(*s)) 
         DECODE_CROAK("invalid number");
   }

   DECODE_CROAK("overflow");
}

static void push_data(struct decode *decode, SV *data) {
   if (decode_height(decode)) {
      struct decode_stack_entry *e = decode_top(decode);

      if (SvTYPE(SvRV(e->sv)) == SVt_PVAV) { /* array */
         av_push((AV*)SvRV(e->sv), data);
      } else if (SvTYPE(SvRV(e->sv)) == SVt_PVHV) { /* hash */
         if (!e->key) {
            if (SvROK(data)) DECODE_CROAK("dictionary keys must be strings");
            e->key = data;
         } else {
            if (!hv_store_ent((HV*)SvRV(e->sv), e->key, data, 0))
               SvREFCNT_dec(data);
            SvREFCNT_dec(e->key);
            e->key = NULL;
         }
      } else {
         SvREFCNT_dec(data);
         DECODE_CROAK("this should never happen");
      }
   } else {
      decode_push(decode, data);
   }
}

static void pop_data(struct decode *decode) {
   struct decode_stack_entry *e;
   
   if (!decode_height(decode)) DECODE_CROAK("format error");

   e = decode_pop(decode);
   if (e->key) {
      SvREFCNT_dec(e->sv);
      SvREFCNT_dec(e->key);
      DECODE_CROAK("dictionary key with no value");
   }
   push_data(decode, e->sv);
}

static void _cleanse(SV *sv) {
   if (SvIOK(sv) && !SvNOK(sv) && !SvPOK(sv)) return;
   (void)SvIV(sv);
   SvIOK_only(sv);
}

static SV* _bdecode(struct decode *decode) {
   I32 depth = 0;
   I32 coerce = SvTRUE(get_sv("Convert::Bencode_XS::COERCE", TRUE));

   while(decode->ptr < decode->end) {
      if (*decode->ptr == 'l') { /* array */
         decode_push(decode, newRV_noinc((SV*)newAV()));
         depth++;
         decode->ptr++;
      } else if (*decode->ptr == 'd') { /* hash */
         decode_push(decode, newRV_noinc((SV*)newHV()));
         depth++;
         decode->ptr++;
      } else if (*decode->ptr == 'e') { /* end of hash/array */
         pop_data(decode);
         depth--;
         decode->ptr++;
      } else if (*decode->ptr == 'i') { /* integer */
         STRLEN len;
         SV *n;

         decode->ptr++;
         len = find_num(decode, 'e', 1);
         if (!len)
            DECODE_CROAK("number must have nonzero length");

         n = newSVpvn(decode->ptr, len);
         if (!coerce) _cleanse(n);
         push_data(decode, n);

         decode->ptr += len + 1;
      } else if (isDIGIT(*decode->ptr)) { /* string */
         STRLEN strlen, numlen = find_num(decode, ':', 0);

         OVERFLOW_IF(decode->ptr + 1 + numlen > decode->end);

         errno = 0;
         strlen = strtol(decode->ptr, NULL, 10);
         if (errno)
            DECODE_CROAK("invalid number");

         decode->ptr += 1 + numlen;
         OVERFLOW_IF(decode->ptr + strlen > decode->end);
         push_data(decode, newSVpvn(decode->ptr, strlen));

         decode->ptr += strlen;
      } else {
         DECODE_CROAK("bad format");
      }
   }

   OVERFLOW_IF(decode->ptr > decode->end);

   if (decode_height(decode) != 1 || depth)
      DECODE_CROAK("bad format");

   return(decode_pop(decode)->sv);
}

#line 310 "Bencode_XS.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 454 "Bencode_XS.c"

XS_EUPXS(XS_Convert__Bencode_XS_bencode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Convert__Bencode_XS_bencode)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "stuff");
    {
	SV *	stuff = ST(0)
;
#line 307 "Bencode_XS.xs"
        SV *line = newSV(8100);
#line 467 "Bencode_XS.c"
	SV *	RETVAL;
#line 309 "Bencode_XS.xs"
        sv_setpv(line, "");
        _bencode(
            line, 
            stuff, 
            SvTRUE(get_sv("Convert::Bencode_XS::COERCE", TRUE)), 
            0
        );
        RETVAL = line;
#line 478 "Bencode_XS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Convert__Bencode_XS_bdecode); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Convert__Bencode_XS_bdecode)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "string");
    {
	SV *	string = ST(0)
;
	SV *	RETVAL;
#line 325 "Bencode_XS.xs"
      struct decode decode;

      if (!SvPOK(string))
         croak("bdecode only accepts scalar strings");

      decode.start = SvPV(string, decode.len);
      decode.end = decode.start + decode.len;
      decode.ptr = decode.start;

      decode.stack_next = 0;
      decode.stack_size = 128;
      New(0, decode.stack_entries, decode.stack_size, struct decode_stack_entry);

      RETVAL = _bdecode(&decode);

      decode_free(&decode);
#line 513 "Bencode_XS.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Convert__Bencode_XS_cleanse); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Convert__Bencode_XS_cleanse)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sv");
    {
	SV *	sv = ST(0)
;
#line 349 "Bencode_XS.xs"
        _cleanse(sv);
#line 532 "Bencode_XS.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Convert__Bencode_XS); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Convert__Bencode_XS)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Convert::Bencode_XS::bencode", XS_Convert__Bencode_XS_bencode, file, "$");
        (void)newXSproto_portable("Convert::Bencode_XS::bdecode", XS_Convert__Bencode_XS_bdecode, file, "$");
        (void)newXSproto_portable("Convert::Bencode_XS::cleanse", XS_Convert__Bencode_XS_cleanse, file, "$");
#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

